unit ClockClient4MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, StdCtrls, OleServer, Clock_TLB;

type
  TClockClientForm = class(TForm)
    btnSetAlarm: TButton;
    Timer1: TTimer;
    Bar: TStatusBar;
    lblMsg: TLabel;
    ClockServer: TApplication;
    procedure Timer1Timer(Sender: TObject);
    procedure btnSetAlarmClick(Sender: TObject);
    procedure ClockServerAlarmRing(Sender: TObject; var Clock: OleVariant;
      AlarmDateTime: TDateTime);
    procedure ClockServerAlarmSet(Sender: TObject; var Clock: OleVariant;
      AlarmDateTime: TDateTime);
  end;

var
  ClockClientForm: TClockClientForm;

implementation

{$R *.DFM}

uses
  ComObj;

procedure TClockClientForm.Timer1Timer(Sender: TObject);
begin
  try
    Bar.Panels[0].Text := DateTimeToStr(ClockServer.CurrentDateTime);
    if ClockServer.AlarmSet then
      Bar.Panels[1].Text := 'Alarm set'
    else
      Bar.Panels[1].Text := 'Alarm not set';
  except
    Bar.Panels[0].Text := 'N/A';
    Bar.Panels[1].Text := 'N/A';
  end
end;

procedure TClockClientForm.btnSetAlarmClick(Sender: TObject);
begin
  if not ClockServer.AlarmSet then
    ClockServer.Alarm := Now + (5 / SecsPerDay)
  else
    ShowMessage('Alarm already set!')
end;

procedure TClockClientForm.ClockServerAlarmRing(Sender: TObject;
  var Clock: OleVariant; AlarmDateTime: TDateTime);
var
  I: Integer;
begin
  Bar.Panels[2].Text := Format(
    'Alarm rang at %s. Time is now %s',
    [DateTimeToStr(AlarmDateTime),
     TimeToStr(Clock.CurrentDateTime)]);
  lblMsg.Caption := 'Ring!!!';
  for I := 0 to 8 do
  begin
    lblMsg.Font.Size := Succ(I mod 3) * 8;
    lblMsg.Update;
    Sleep(100)
  end;
  lblMsg.Caption := '';
end;

procedure TClockClientForm.ClockServerAlarmSet(Sender: TObject;
  var Clock: OleVariant; AlarmDateTime: TDateTime);
begin
  Bar.Panels[2].Text := Format(
    'Alarm set for %s. Time is now %s',
    [DateTimeToStr(AlarmDateTime),
     TimeToStr(Clock.CurrentDateTime)])
end;

end.
